option add *Listbox*font \
    "-*-helvetica-medium-r-normal-*-12-*-*-*-p-*-iso8859-1" startupFile
option add *Entry*font \
    "-*-helvetica-medium-r-normal-*-12-*-*-*-p-*-iso8859-1" startupFile
option add *Label*font \
    "-*-helvetica-medium-r-normal-*-12-*-*-*-p-*-iso8859-1" startupFile

# this is the default proc  called when "OK" is pressed
# indicate your own proc as an argument to about

proc about.default.cmd {f} {
    global about
    destroy $w
}


# this is the default proc called when error is detected
# indicate your own proc as an argument to about

proc about.default.errorHandler {errorMessage} {
    puts stdout "error: $errorMessage"
    catch { cd ~ }
}

# this is the proc that creates the about window

proc about {
    {cmd about.default.cmd} 
    {w .aboutWindow} 
    {errorHandler about.default.errorHandler}} {

    catch {destroy $w}

    toplevel $w
    grab $w
    wm title $w "About MessMenu"


    # path independent names for the widgets
    global about
    set about(text) $w.about.sframe.text 
    set about(scroll) $w.about.sframe.scroll
    set about(ok) $w.bframe.okframe.ok

    # widgets
    frame $w.about -bd 5 
    frame $w.bframe -bd 5
    pack append $w \
        $w.about {top filly} \
        $w.bframe {bottom expand frame n}

    frame $w.about.sframe

    pack append $w.about \
	$w.about.sframe {top fillx}


    text $w.about.sframe.text -width 40 -height 10 -yscrollcommand "$w.about.sframe.yscroll set"
    scrollbar $w.about.sframe.yscroll -relief sunken \
	 -command "$w.about.sframe.text yview"
#    text $w.about.sframe.text -width 40 -height 15
    $w.about.sframe.text insert end {
About MessMenu V0.7.0
----------
This program was designed as a front
end menu to sdlmess.

It is released under the terms of the
GPL (GNU Public License) version 2.0
or later.

Made by Barry Nelson
E-Mail : root@star2.abcm.com

Change log:
0.7.0	07/19/2009
	Fixed multiple bugs, cleaned up
	and optimized code
	Updated to work with sdlmess
	version 0132
0.6.3	09/24/2008
	Added a drop menu item to edit
	mess.ini
	Added a drop menu item to reset
	mess.ini to defaults
	Rewrote the file selector to
	allow multiple disks or
	cartridges to be selected
0.6.2	09/21/2008
	Worked arround a minor bug in
	sdlmess 0.127 that saves the
	paths to floppy files wrong.
	Updated the mess binary to
	0.127 universal (ppc and intel).
0.6.1	08/05/2008
	Fixed startup script to detect
	when executable is moved and
	have it re-init .messdir
0.6.0	05/05/2008
	Added preferences dialog to
	change default mess.ini settings.
0.5.3	05/05/2008
	Included SDL framework inside app
0.5.2	05/03/2008
	Corrected another space bug in
	the launcher script. Also added
	a warning if the rom does not
	exist.
0.5.1	05/03/2008
	Corrected silly bug that caused
	errors if certain directories
	contained spaces.

0.5	05/02/2008
	Initial release :-)
    }
#    pack append $w.about.sframe \
#        $w.about.sframe.yscroll {right filly} \
# 	$w.about.sframe.text {left expand fill} 
    pack append $w.about.sframe \
        $w.about.sframe.yscroll {right filly} \
 	$w.about.sframe.text {left expand fill} 

    # buttons
#    frame $w.bframe.okframe -borderwidth 2 -relief sunken
    frame $w.bframe.okframe -borderwidth 2
 
    button $w.bframe.okframe.ok -text OK -relief raised \
        -command "about.ok.cmd $w $cmd $errorHandler"

    pack append $w.bframe.okframe $w.bframe.okframe.ok {padx 5 pady 5}

    pack append $w.bframe $w.bframe.okframe {expand padx 5 pady 5}

}


# auxiliary button procedures

proc about.ok.cmd {w cmd errorHandler} {
    global about
    destroy $w
}
